<?php

// IPB 1.3 to MyBB 1.0.x, 1.1.x Importer

/*
* EDIT PATH TO YOUR IPB AND MYBB UPLOADSFOLDER!
*/
// define path to invision power board, with trailing slash, example: /home/user/public_html/forums/
$ipb_path = '';
// define path to your mybb uploadsfolder, without trailing slash! example: /home/user/public_html/mybb/uploads
$mybb_uploadspath = '';
/*
* NO MORE EDITING!
*/


// include mybb config file
include './inc/config.php';

// Include the conf_global.php from IPB
include $ipb_path . 'conf_global.php';
$source_table_prefix = $INFO['sql_tbl_prefix'];
$attachment_folder = $INFO['upload_url'];
/* Editing End*/

print '
<html>
<head>
<title>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Importer</title>
<style type="text/css"><!-- 
h1 {font-size:18px;color:#000000;margin:0px;}
h2 {font-size:14px;color:#000000;}
body 
{
 font-family:Verdana;
 font-size:12px;
 background-color:#FFFFFF;
}
--></style>
</head>
<body>
';


// Lets Start! Make Sure we select an existing Step
if (isset($_GET['import'])) 
{
	$import = array('start', 'usergroups','users', 'cats', 'forums', 'topics', 'posts', 'polls', 'attachments', 'pms', 'finished', 'fixes');
	
	if (in_array($_GET['import'],$import, TRUE))
	{
		if($_GET['import'] == '')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_start();
		}

		if($_GET['import'] == 'usergroups')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_usergroups();
		}

		if($_GET['import'] == 'users')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_users();
		}

		if($_GET['import'] == 'cats')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_categories();
		}

		if($_GET['import'] == 'forums')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_forums();
		}

		if($_GET['import'] == 'topics')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_topics();
		}

		if($_GET['import'] == 'posts')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_posts();
		}

		if($_GET['import'] == 'polls')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_polls();
		}

		if($_GET['import'] == 'attachments')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_attachments();
		}

		if($_GET['import'] == 'pms')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_pms();
		}
		
		if($_GET['import'] == 'fixes')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_fixes();
		}

		if($_GET['import'] == 'finished')
		{
			print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
			import_finished();
		}
	}
	else
	{
		print 'Selected Import Job doesnt exist, please recheck your Selection';
	}
}
else
{
	print '<h1>Invision Power Board 1.3.x to MyBB 1.0.x , 1.1.x Converter</h1><br />';
	import_start();
}


// First we import all Usergroups
function import_usergroups()
{
	global $INFO, $config, $source_table_prefix;
	
	//---------------------------
	// Limit rows
	//---------------------------
		
	$end   = 1000;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Users and save it in an array
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	$user_groups_array = array();
	$sql = "SELECT * FROM " .$source_table_prefix."groups ORDER BY g_id LIMIT $start, $end";
	$user_groups = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($user_groups))
	{
		// We are done?
		print '<h4>Usergroups conversion complete! Please wait for next Step (User Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=users");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
	
		exit();
	}
	
	while ($user_group = mysql_fetch_array($user_groups))
	{
		$user_groups_array["$user_group[g_id]"] = $user_group;
	}
	// Done, now go to Import Process
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	if($start == '0')
	{
		// Add an Extra Field , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."usergroups ADD `importusergroupid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	print "<h4>Importing " . count($user_groups_array) . " usergroups ...";
	
	// Prepare, we will only Import Custom Usergroups
	$ipb_admin_group = $INFO['admin_group'];
	$ipb_activation_group = $INFO['auth_group'];
	$ipb_guest_group = $INFO['guest_group'];
	$ipb_member_group = $INFO['member_group'];
	
	foreach ($user_groups_array as $user_group_id => $user_group)
	{
		// Make sure we only import the Custom Usergroups
		if ($user_group_id == $ipb_admin_group)
		{
		}
		elseif ($user_group_id == $ipb_activation_group)
		{
		}
		elseif ($user_group_id == $ipb_guest_group)
		{
		}
		elseif ($user_group_id == $ipb_member_group)
		{
		}
		else
		{
		
			$title = $user_group['g_title'];
			$type = '2';
			$canview = $user_group['g_can_view'] == '1' ? 'yes' : 'no';
			$canviewprofiles = $user_group['g_mem_info'] == '1' ? 'yes' : 'no';
			$canpostthreads = $user_group['g_post_new_topics'] == '1' ? 'yes' : 'no';
			$canpostreplys = $user_group['g_reply_other_topics'] == '1' ? 'yes' : 'no';
			$cancp = $user_group['g_access_cp'] == '1' ? 'yes' : 'no';
			$canuploadavatars = $user_group['g_avatar_upload'] == '1' ? 'yes' : 'no';
			$caneditposts = $user_group['g_edit_posts'] == '1' ? 'yes' : 'no';
			$canpostpolls = $user_group['g_post_polls'] == '1' ? 'yes' : 'no';
			$canvotepolls = $user_group['g_vote_polls'] == '1' ? 'yes' : 'no';
			$canusepms = $user_group['g_use_pm'] == '1' ? 'yes' : 'no';
			$cansendemail = $user_group['g_email_friend'] == '1' ? 'yes' : 'no';
			$canusercp = $user_group['g_edit_profile'] == '1' ? 'yes' : 'no';
			$issupermod = $user_group['g_is_supmod'] == '1' ? 'yes' : 'no';
			$candeleteposts = $user_group['g_delete_own_posts'] == '1' ? 'yes' : 'no';
			$cansearch = $user_group['g_use_search'] == '1' ? 'yes' : 'no';
			$canviewmemberlist = $user_group['g_mem_info'] == '1' ? 'yes' : 'no';
			$candeletethreads = $user_group['g_delete_own_topics'] == '1' ? 'yes' : 'no';
			$image = $user_group['g_icon'];
			$canaddpublicevents = $user_group['g_calendar_post'] == '1' ? 'yes' : 'no';
			// if Group can use PM System
			if ($user_group['g_use_pm'] == '1')
			{
				$pmquota = $user_group['g_max_messages'];
				$cansendpms = 'yes';
				$cantrackpms = 'yes';
				$candenypmreceipts = 'yes';
			}
			else
			{
				$pmquota = '0';
				$cansendpms = 'no';
				$cantrackpms = 'no';
				$candenypmreceipts = 'no';
			}
			// There is nothing that equals in IPB Groups
			$usereputationsystem = 'yes';
			$cangivereputations = 'yes';
			$reputationpower = '1';
			$maxreputationsday = '5';
			$cancustomtitle = 'no';
			$canratemembers = 'yes';
			$isbannedgroup = 'no';
			$candlattachments = 'yes';
			$canpostattachments = 'yes';
			$caneditattachments = 'yes';
			$canratethreads = 'yes';
			$showforumteam = 'no';
			$canchangename = 'no';
			$attachquota = '10000';
			$usertitle = '';
			$stars = '0';
			$canviewcalendar = 'yes';
			$canaddprivateevents = 'no';
			$canviewonline = 'yes';
			$canviewwolinvis = 'no';
			$canviewonlineips = 'no';
			$importusergroupid = $user_group_id;
			
			mysql_query("INSERT INTO ".$config[table_prefix]."usergroups
					(title,type,canview,canviewprofiles,canpostthreads,canpostreplys,cancp,canuploadavatars,caneditposts,
					canpostpolls,canvotepolls,canusepms,cansendemail,canusercp,issupermod,candeleteposts,cansearch,canviewmemberlist,
					candeletethreads,image,canaddpublicevents,pmquota,cansendpms,cantrackpms,candenypmreceipts,usereputationsystem,
					cangivereputations,reputationpower,maxreputationsday,cancustomtitle,canratemembers,isbannedgroup,candlattachments,canpostattachments,
					canratethreads,showforumteam,canchangename,attachquota,usertitle,stars,canviewcalendar,canaddprivateevents,canviewonline,canviewonlineips,canviewwolinvis, importusergroupid)
					VALUES 
					('".$title."', '".$type."', '".$canview."', '".$canviewprofiles."', '".$canpostthreads."', '".$canpostreplys."', '".$cancp."', 
					'".$canuploadavatars."', '".$caneditposts."', '".$canpostpolls."', '".$canvotepolls."', '".$canusepms."', '".$cansendemail."', 
					'".$canusercp."', '".$issupermod."', '".$candeleteposts."', '".$cansearch."', '".$canviewmemberlist."', '".$candeletethreads."', 
					'".$image."', '".$canaddpublicevents."', '".$pmquota."', '".$cansendpms."', '".$cantrackpms."', '".$candenypmreceipts."', '".$usereputationsystem."',
					'".$cangivereputations."', '".$reputationpower."', '".$maxreputationsday."', '".$cancustomtitle."', '".$canratemembers."', '".$isbannedgroup."',
					'".$candlattachments."', '".$canpostattachments."', '".$canratethreads."', '".$showforumteam."', '".$canchangename."', '".$attachquota."', '".$usertitle."',
					'".$stars."', '".$canviewcalendar."', '".$canaddprivateevents."', '".$canviewonline."', '".$canviewonlineips."', '".$canviewwolinvis."', '".$importusergroupid."')
					") or die(mysql_error());
		}
		
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=usergroups&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
	
}

// After we import the IPB Usergroups we import all Users, lets go!
function import_users()
{
	global $INFO, $config, $source_table_prefix;
	
	//---------------------------
	// Limit rows
	//---------------------------
		
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Users and save it in an array
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);

	$user_array = array();
	$sql = "SELECT * FROM " .$source_table_prefix."members ORDER BY id LIMIT $start, $end";
	$users = mysql_query($sql,$ipb_db) or die(mysql_error());
	
	if ( ! mysql_num_rows($users))
	{
		// We are done?
		print '<h4>User conversion complete! Please wait for next Step (Categorie Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=cats");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($user = mysql_fetch_array($users))
	{
		$user_array["$user[id]"] = $user;
	}
	// Done, now go to Import Process
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	if($start == '0')
	{
		// Clean Up Users table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."users");
	
		// Add an Extra Field , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."users ADD `importuserid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	print "<h4>Importing " . count($user_array) . " users ...";
	
	foreach ($user_array as $user_id => $user)
	{
		$username 	= $user['name'];
		$regdate  	= (int) $user['joined'];
		$postnum 	= (int) $user['posts'];
		
		// Usergroups, a little bit Tricky
		if($user['mgroup'] == $INFO['admin_group'])
		{
			$usergroup = '4';
		}
		elseif($user['mgroup'] == $INFO['member_group'])
		{
			$usergroup = '2';
		}
		elseif($user['mgroup'] == $INFO['auth_group'])
		{
			$usergroup = '5';
		}
		else
		{
			$get_id = mysql_query("SELECT gid FROM ".$config[table_prefix]."usergroups WHERE importusergroupid = '".$user['mgroup']."'") or die(mysql_error());
			$result = mysql_fetch_array($get_id);
			$usergroup = $result['gid'];
		}
		$lastvisit 	= (int) $user['last_visit'];
		$password	= $user['password'];
		$email 		= $user['email'];
		$website 	= $user['website'];
		$icq 		= $user['icq_number'];
		$aim 		= $user['aim_name'];
		$yahoo		= $user['yahoo'];
		$msn 		= $user['msnname'];
		$hideemail 	= $user['hide_email'];
		$avatar 	= $user['avatar'];
		$usertitle 	= $user['title'];
		$allownotices	= $user['allow_admin_mails'];
		$lastpost 	= (int) $user['last_post'];
		$showsigs 	= $user['view_sigs'];
		$showavatars 	= $user['view_avs'];
		$importuserid	= $user['id'];
		
		if($user['bday_day'] != null AND $user['bday_month'] != null AND $user['bday_year'] != null)
		{
			$birthday =	$user['bday_day'] . "-" . $user['bday_month'] . "-" . $user['bday_year'];
		}
		else
		{
			$birthday = "";
		}
		
		$signature	= addslashes(ipb_html($user['signature']));
			
		mysql_query("INSERT INTO ".$config[table_prefix]."users 
							(username,usergroup,regdate,postnum,lastvisit,password,email,website,icq,aim,yahoo,msn,hideemail,avatar,usertitle,allownotices,lastpost,showsigs,showavatars,importuserid,birthday)
						VALUES 
							('".$username."', '".$usergroup."', '".$regdate."', '".$postnum."', '".$lastvisit."', '".$password."', '".$email."', '".$website."', '".$icq."', '".$aim."', '".$yahoo."', '".$msn."', '".$hideemail."', '".$avatar."', '".$usertitle."', '".$allownotices."', '".$lastpost."', '".$showsigs."', '".$showavatars."', '".$importuserid."', '".$birthday."')
					") or die(mysql_error());
		unset($birthday);
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=users&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Users we import all Categories, lets go!
function import_categories()
{
	global $INFO, $config, $source_table_prefix;
	
	//---------------------------
	// Limit rows
	//---------------------------
		
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Categories and save it in an array
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);

	$categories_array = array();
	$sql = "SELECT * FROM " .$source_table_prefix."categories ORDER BY id LIMIT $start, $end";
	$categories = mysql_query($sql,$ipb_db) or die(mysql_error());
	
	if ( ! mysql_num_rows($categories))
	{
		// We are done?
		print '<h4>Categorie conversion complete! Please wait for next Step (Forum Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=forums");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($category = mysql_fetch_array($categories))
	{
		$categories_array["$category[id]"] = $category;
	}
	// Done, now go to Import Process
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	
	if($start == '0')
	{
		// Clean Up Forums table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."forums");
	
		// Add some Extra Fields , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."forums ADD `importcategoryid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
		@mysql_query("ALTER TABLE ".$config[table_prefix]."forums ADD `importforumid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	print "<h4>Importing " . count($categories_array) . " categories ...";
	
	foreach ($categories_array as $category_id => $category)
	{
		// If its not the first blank one
		if($category_id != '-1')
		{
			$name = addslashes($category['name']);
			$disporder = (int) $category['position'];
			$parentid = '-1';
			$linkto = $category['url'];
			$type = 'c';
			$pid = '0';
			$importcategoryid = (int) $category['id'];
			$importforumid = '0';
			
			mysql_query("INSERT INTO ".$config[table_prefix]."forums (name,type,pid,parentlist,disporder,importcategoryid,importforumid)
															  VALUES ('".$name."', '".$type."', '".$pid."', '".$parentid."', '".$disporder."', '".$importcategoryid."', '".$importforumid."')
						") or die(mysql_error());
		}
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=cats&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Categories we import all Forums, lets go!
function import_forums()
{
	global $config, $INFO, $source_table_prefix;
	
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	// Limit rows
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Forums and save it in an array
	$forum_array = array();

	$sql = "SELECT * FROM " .$source_table_prefix."forums ORDER BY id LIMIT $start, $end";
	$forums = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($forums))
	{
		// We are done? Redirect to next Step
		print '<h4>Forums conversion complete! Please wait for next Step (Topic Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=topics");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($forum = mysql_fetch_array($forums))
	{
		$forum_array["$forum[id]"] = $forum;
	}
	
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	print "<h4>Importing " . count($forum_array) . " forum(s) ...";
	
	$target_table_prefix = $config[table_prefix];
	
	foreach ($forum_array as $forum_id => $forum)
	{
		
		$forum_ids 		= get_forum_ids($target_table_prefix);
		$cat_ids 		= get_category_ids($target_table_prefix);
		
		if(!$forum_ids["$forum[parent_id]"])
		{
			$parentid = '-1';
		}
		else
		{
			$parentid = $forum_ids["$forum[parent_id]"];
		}

		if ($parentid == '-1')
		{
			$parentid = $cat_ids["$forum[category]"];
		}
		
		$name = addslashes($forum['name']);
		$disporder = (int) $forum['position'];
		$parent_id = (int) $forum['category'];
		
		$description = $forum['description'];
		$posts = (int) $forum['posts'];
		$threads = (int) $forum['topics'];
		$last_post = (int) $forum['last_post'];
		$last_poster = $forum['last_poster_name'];
		$type = 'f';
		$parentlist = '0';
		$importforumid = (int) $forum_id;
		$importcategoryid = '0';
		
		mysql_query("INSERT INTO  ".$config[table_prefix]."forums (name,type,pid,parentlist,disporder,lastpost,lastposter,posts,threads,importforumid,importcategoryid)
														   VALUES ('".$name."', '".$type."', '".$parentid."', '".$parentlist."', '".$disporder."', '".$last_post."', '".$last_poster."', '".$posts."', '".$threads."', '".$importforumid."', '".$importcategoryid."')
					") or die(mysql_error());
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=forums&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Forums we import all Threads, lets go!
function import_topics()
{
	global $config, $INFO, $source_table_prefix;
	
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	// Limit rows
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Topics and save it in an array
	$topics_array = array();

	$sql = "SELECT * FROM " .$source_table_prefix."topics ORDER BY tid LIMIT $start, $end";
	$topics = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($topics))
	{
		// We are done? Redirect to next Step
		print '<h4>Topics conversion complete! Please wait for next Step (Posts Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=posts");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($topic = mysql_fetch_array($topics))
	{
		$topics_array["$topic[tid]"] = $topic;
	}
	
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	print "<h4>Importing " . count($topics_array) . " Thread(s) ...";
	
	if($start == '0')
	{
		// Clean Up Threads table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."threads");
	
		// Add some Extra Fields , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."threads ADD `importforumid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
		@mysql_query("ALTER TABLE ".$config[table_prefix]."threads ADD `importthreadid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	$target_table_prefix = $config[table_prefix];
	
	$forum_ids 				= get_forum_ids($target_table_prefix);
	$users_ids 				= get_user_ids($target_table_prefix);
	$user_names				= get_username($target_table_prefix);
	
	foreach ($topics_array as $topic_id => $topic)
	{
		$subject 			= $topic['title'];
		$fid 				= (int) $forum_ids[$topic['forum_id']]; 
		$importthreadid		= (int) $topic_id;
		$importforumid		= (int) $topic['forum_id'];
		$uid				= (int) $users_ids[$topic['starter_id']];
		$username			= $user_names['starter_name'];
		$dateline			= (int) $topic['start_date'];
		$views				= (int) $topc['views'];
		$replies			= (int) $topic['posts'];
		$notes				= $topic['description'];
		$lastpost			= (int) $topic['last_post'];
		$lastposter			= $topic['last_poster_name'];
		$sticky				= (int) $topic['pinned'];
		$visible			= '1';
		
		if ($topic['state'] == 'open')
		{
			$closed = 'no';
		}
		else if ($topic['state'] == 'closed')
		{
			$closed = 'yes';
		}
		
		mysql_query("INSERT INTO  ".$config[table_prefix]."threads 
				(subject,fid,importthreadid,importforumid,uid,username,dateline,views,replies,notes,lastpost,lastposter,sticky,visible,closed) 
		VALUES ('".$subject."', '".$fid."', '".$importthreadid."', '".$importforumid."', '".$uid."', '".$username."', '".$dateline."', '".$views."', '".$replies."', '".$notes."', '".$lastpost."', '".$lastposter."', '".$sticky."', '".$visible."', '".$closed."')
		") or die(mysql_error());
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=topics&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Threads we import all Posts, lets go!
function import_posts()
{
	global $config, $INFO, $source_table_prefix;
	
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	// Limit rows
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Posts and save it in an array
	$posts_array = array();

	$sql = "SELECT * FROM " .$source_table_prefix."posts ORDER BY pid LIMIT $start, $end";
	$posts = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($posts))
	{
		// We are done? Redirect to next Step
		print '<h4>Posts conversion complete! Please wait for next Step (Polls Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=polls");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	else
	{
	
		while ($post = mysql_fetch_array($posts))
		{
			$posts_array["$post[pid]"] = $post;
		}
	}
	
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	print "<h4>Importing " . count($posts_array) . " Posts(s) ...";
	
	if($start == '0')
	{
		// Clean Up Posts table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."posts");
		// Add some Extra Fields , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."posts ADD `importthreadid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
		@mysql_query("ALTER TABLE ".$config[table_prefix]."posts ADD `importpostid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	$target_table_prefix = $config[table_prefix];
	
	$thread_ids				= get_threads_ids($target_table_prefix);
	$users_ids 				= get_user_ids($target_table_prefix);
	
	foreach ($posts_array as $post_id => $post)
	{
		$tid 			= (int) $thread_ids[$post['topic_id']];
		$uid 			= (int) $users_ids[$post['author_id']];
		$importthreadid = (int) $post['topic_id'];
		$importpostid	= (int) $post_id;
		$dateline		= (int) $post['post_date'];
		$username		= $post['author_name'];
		$ipaddress		= $post['ip_address'];
		
		if ($post['use_sig'] == '1')
		{
			$includesig = 'yes';
		}
		else
		{
			$includesig = 'no';
		}
		
		if ($post['use_emo'] == '1')
		{
			$smilieoff = 'yes';
		}
		else
		{
			$smilieoff = 'no';
		}
		
		$message		= addslashes(ipb_html($post['post']));
		$subject		= $post['post_title'];
		$visible		= '1';
		$edittime		= (int) $post['edit_time'];
		
		mysql_query("INSERT INTO  ".$config[table_prefix]."posts 
				(tid,uid,importthreadid,importpostid,dateline,username,ipaddress,includesig,smilieoff,message,subject,visible,edittime) 
		VALUES ('".$tid."', '".$uid."', '".$importthreadid."', '".$importpostid."', '".$dateline."', '".$username."', '".$ipaddress."', '".$includesig."', '".$smilieoff."', '".$message."', '".$subject."', '".$visible."', '".$edittime."')
		") or die(mysql_error());
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=posts&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Posts we import all Polls, lets go!
function import_polls()
{
	global $config, $INFO, $source_table_prefix;
	
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	// Limit rows
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Polls and save it in an array
	$polls_array = array();

	$sql = "SELECT * FROM " .$source_table_prefix."polls ORDER BY pid LIMIT $start, $end";
	$polls = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($polls))
	{
		// We are done? Redirect to next Step
		print '<h4>Polls conversion complete! Please wait for next Step (Attachments Conversion)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=attachments");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($poll = mysql_fetch_array($polls))
	{
		$polls_array["$poll[pid]"] = $poll;
	}
	
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	print "<h4>Importing " . count($polls_array) . " Polls(s) ...";
	
	if($start == '0')
	{
		// Clean Up Polls and Pollvotes table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."polls");
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."pollvotes");
	
		// Add some Extra Fields , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."polls ADD `importpollid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	$target_table_prefix = $config[table_prefix];
	
	$thread_ids				= get_threads_ids($target_table_prefix);
	$users_ids 				= get_user_ids($target_table_prefix);
	
	foreach ($polls_array as $poll_id => $poll)
	{
		$optionsstring 	= '';
		$votesstring 	= '';
		$numberoptions 	= 0;
		$voters 		= 0;
		unset($poll_voters_array);

		$poll_answers = unserialize(stripslashes($poll['choices']));

		while ($pollinfo = each($poll_answers))
		{
			$optionsstring .= unhtmlspecialchars($pollinfo['1']['1'])."||~|~||";
			// sanity check for votes count
			$votesbit = intval($pollinfo['1']['2']);
			if ($votesbit < 0)
			{
				$votesbit = 0;
			}
			$voters += $votesbit;
			$votesstring .= $votesbit."||~|~||";
			$numberoptions++;
		}

		unset($poll_answers);
		$poll['options'] = $optionsstring;
		$poll['votes'] = $votesstring;
		
		if(!$poll['poll_question'])
		{
			$question = 'No question to import.';
		}
		else
		{
			$question = $poll['poll_question'];
		}
		
		$importpollid = $poll_id;
		$dateline = $poll['start_date'];
		$options = $poll['options'];
		$votes = $poll['votes'];
		$numoptions = $numberoptions;
		$timeout = '0';
		$multiple = '0';
		$voters = $voters;
		$public = '1';
		$import_thread_id = $poll['tid'];
		
		// If "forum_poll_voters"
		$poll_voters = get_ipb_poll_voters($source_table_prefix, $import_thread_id);
		
		$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
		mysql_select_db($config[database], $mybb_db);
			
		$result = mysql_query("INSERT INTO  ".$config[table_prefix]."polls 
				(importpollid,question,dateline,options,votes,numoptions,timeout,multiple,public) 
		VALUES ('".$importpollid."', '".$question."', '".$dateline."', '".$options."', '".$votes."', '".$numoptions."', '".$timeout."', '".$multiple."', '".$public."')
		") or die(mysql_error());
		
		$mybb_poll_id = mysql_insert_id();
		
		if(!empty($poll_voters))
		{
			foreach ($poll_voters AS $mybb_user_id => $vote_option)
			{
				if(empty($mybb_user_id))
				{
					continue;
				}
				if ($vote_option == 0 OR empty($vote_option))
				{
					$sql = "INSERT INTO " . $config[table_prefix] . "pollvotes (pid, uid) VALUES ('".$mybb_poll_id."', '".$mybb_user_id."')";
				}
				else
				{
					$sql = "INSERT INTO " . $config[table_prefix] . "pollvotes (pid, uid, voteoption) VALUES ('".$mybb_poll_id."', '".$mybb_user_id."', '".$vote_option."')";
				}

				mysql_query($sql) or die(mysql_error());
			}
		}
		
		mysql_query("UPDATE " . $config[table_prefix] . "threads SET poll = ".$mybb_poll_id." WHERE importthreadid = ".$import_thread_id) or die(mysql_error());
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=polls&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Polls we import all Attachments, lets go!
function import_attachments()
{
	global $INFO, $config, $source_table_prefix, $attachment_folder, $mybb_uploadspath;
	
	//---------------------------
	// Limit rows
	//---------------------------
		
	$end   = 10;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Attachments and save it in an array
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);

	$attachment_array = array();
	$sql = "SELECT pid, post_date,attach_id, attach_hits, attach_type, attach_file, author_id FROM " .$source_table_prefix."posts 
			WHERE attach_file != ''
			AND attach_file != '|'
			LIMIT $start, $end";
	$attachments = mysql_query($sql,$ipb_db) or die(mysql_error());
	
	if ( ! mysql_num_rows($attachments))
	{
		// We are done?
		print '<h4>Attachment conversion complete! Please wait for next Step (PMs Conversion!)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=pms");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		
		exit();
	}
	
	while ($attachment = mysql_fetch_array($attachments))
	{
		$attachment_array[] = $attachment;
	}
	// Done, now go to Import Process
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	if($start == '0')
	{
		// Clean Up Attachments table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."attachments");
		// Add some Extra Fields , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."attachments ADD `importattachmentid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	print "<h4>Importing " . count($attachment_array) . " Attachments ...";
	
	$i = 0;
	foreach ($attachment_array as $post_id => $attachment)
	{
		$filename = $attachment['attach_id'];
		$original= $attachment['attach_file'];
		$counter  = $attachment['attach_hits'];
		

		$the_file = get_ipb_attachment($attachment_folder, $filename);
		$importattachmentid = $i+1;
		$visible = '1';
		$downloads = $attachment['attach_hits'];
		$filesize = $the_file['filesize'];
		$pid = $attachment['pid'];
		$uid = $attachment['author_id'];
				
		// Get the real post id
		$get_post_id = mysql_query("SELECT pid, uid FROM ".$config[table_prefix]."posts WHERE importpostid = '".$pid."'") or die(mysql_error());
		$postid = mysql_fetch_array($get_post_id);
		
		/* 
		* Borrowed from MyBB to Generate Thumbnails
		*/
		
		$ext = getextention($attachment['attach_id']);
		
		// Alls well that ends well? Lets generate a thumbnail (if image) and insert it all in to the database
		if($ext == "gif" || $ext == "png" || $ext == "jpg" || $ext == "jpeg" || $ext == "jpe")
		{
			$thumbname = "".strip_file_ext($attachment['attach_id'])."_thumb.".$ext;
			$thumbnail = @generate_thumbnail($mybb_uploadspath."/".$filename, $mybb_uploadspath, $thumbname, '60', '60');
			if($thumbnail['filename'])
			{
				$thumbadd = ",thumbnail";
				$thumbadd2 = ",'".$thumbnail['filename']."'";
			}
			elseif($thumbnail['code'] == 4)
			{
				$thumbadd = ",thumbnail";
				$thumbadd2 = ",'SMALL'";
			}
		}
		else
		{
			$thumbadd = "";
			$thumbadd2 = "";
		}
		

		mysql_query("INSERT INTO " . $config[table_prefix] . "attachments
						(importattachmentid, filename, visible, downloads, filesize, pid, uid, attachname, filetype$thumbadd)
						VALUES
						('".$importattachmentid."', '".$original."', '".$visible."', '".$downloads."', '".$filesize."', '".$postid['pid']."', '".$postid['uid']."', '".$filename."', '".$attachment['attach_type']."'$thumbadd2)
					") or die(mysql_error());
		$i++;
	}
	unset($thumbnail);
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=attachments&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Attachments we import all Private Messages, lets go!
function import_pms()
{
	global $config, $INFO, $source_table_prefix;
	
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	// Limit rows
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all PMs and save it in an array
	$pms_array = array();
	$sql = "SELECT * FROM " . $source_table_prefix . "messages ORDER BY msg_id LIMIT $start, $end";
	$pms = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($pms))
	{
		// We are done? Redirect to next Step
		print '<h4>Private Messages conversion complete! Please wait for next Step (Fix Lastpost Information on Forums)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=fixes");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($pm = mysql_fetch_array($pms))
	{
		$pms_array["$pm[msg_id]"] = $pm;
	}
	
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	print "<h4>Importing " . count($pms_array) . " Private Messages ...";
	
	if($start == '0')
	{
		// Clean Up Posts table_prefix
		mysql_query("TRUNCATE TABLE ".$config[table_prefix]."privatemessages");
	
		// Add some Extra Fields , its for the importer
		@mysql_query("ALTER TABLE ".$config[table_prefix]."privatemessages ADD `importpmid` BIGINT( 20 ) DEFAULT '0' NOT NULL ;");
	}
	
	$target_table_prefix = $config[table_prefix];
	
	$users_ids 				= get_user_ids($target_table_prefix);
	$user_names				= get_username($target_table_prefix);
	
	foreach ($pms_array as $pm_id => $pm)
	{
		$importpmid = (int) $pm_id;
		$fromid = (int) $users_ids[$pm['from_id']];
		$toid = (int) $users_ids[$pm['recipient_id']];
		$uid = (int) $users_ids[$pm['member_id']];
		$message = addslashes(ipb_html($pm['message']));
		$subject = $pm['title'];
		$dateline = (int) $pm['msg_date'];
		$readtime = (int) $pm['read_date'];
		if($pm['vid'] == 'sent')
		{
			$folder = '2';
		}
		else
		{
			$folder = '1';
		}
		$status = '1';
		
		mysql_query("INSERT INTO  ".$config[table_prefix]."privatemessages 
				(importpmid,fromid,toid,uid,message,subject,dateline,readtime,folder,status) 
		VALUES ('".$importpmid."', '".$fromid."', '".$toid."', '".$uid."', '".$message."', '".$subject."', '".$dateline."', '".$readtime."', '".$folder."', '".$status."')
		") or die(mysql_error());
	}
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
	print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=pms&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
}

// After we import the IPB Private Messages we fix the lastposttid on forums table, lets go!
function import_fixes()
{
	global $config, $INFO, $source_table_prefix;
	
	$mybb_db = mysql_connect($config[hostname], $config[username], $config[password], true);
	mysql_select_db($config[database], $mybb_db);
	
	// Limit rows
	$end   = 500;
	$start = $_GET['start'] ? $_GET['start'] : 0;
	
	// Get all Forums and save it in an array
	$forums_array = array();
	$sql = "SELECT fid FROM " . $config[table_prefix] . "forums WHERE type='f' ORDER BY fid LIMIT $start, $end";
	$forums = mysql_query($sql) or die(mysql_error());
	
	if ( ! mysql_num_rows($forums))
	{
		// We are done? Redirect to next Step
		print '<h4>Fixed Lastpost Information complete! Please wait for next Step (Finished Screen)</h4>';
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=finished");
		}
		setTimeout("redirect();", 1000);
		</script>
		';
		exit();
	}
	
	while ($forum = mysql_fetch_array($forums))
	{
		$forums_array["$forum[fid]"] = $forum;
	}
	
	print "<h4>Fixed Lastpost Information for " . count($forums_array) . " Forum(s) ...";
	
	$target_table_prefix = $config[table_prefix];
	
	foreach ($forums_array as $forum_id => $forum)
	{
		$get = mysql_query("SELECT p.tid, t.subject FROM ".$config[table_prefix]."posts p, ".$config[table_prefix]."threads t
							WHERE t.fid = '".$forum_id."' AND p.tid = t.tid
							ORDER BY p.dateline DESC LIMIT 1");
		$result = mysql_fetch_array($get);
		mysql_query("UPDATE ".$config[table_prefix]."forums SET lastposttid='".$result['tid']."' WHERE fid='".$forum_id."'")or die(mysql_error());
	}
	mysql_free_result($get);
	
	// Done?
	// Ok - redirect for the next batch
	$new_start = $start + $end;
		print '
		<script>
		function redirect() {
		window.location.replace("invision_to_mybb.php?import=fixes&start='.$new_start.'");
		}
		setTimeout("redirect();", 1000);
		</script>
		';

}

// First we show an Start Screen, lets go!
function import_start()
{
	print '<p>Welcome to the Import wizard for Invision Power Board to MyBB 1.0.x , 1.1.x. This wizard will imports Data from your Invision Power Board 1.3.x to your new MyBB 1.0.x, 1.1.x.</p>
			<p>Below is an outline of what is going to be completed during conversion.</p>
			<ul>
				<li>Usergroups Conversion</li>
				<li>Users Conversion</li>
				<li>Categories Conversion</li>
				<li>Forums Conversion</li>
				<li>Threads Conversion</li>
				<li>Posts Conversion</li>
				<li>Polls Conversion</li>
				<li>Attachments Conversion</li>
				<li>Private Messages Conversion</li>
			</ul>
			<p>After each step has successfully been completed, wait for the next Step to be completed. <b>Its all be done automatically!!</b> Sit back and wait, drink a beer or a cup of coffee ;-)</p>
			<p><b>Notes: You must a use a fresh installed MyBB! All Data in your MyBB Installation is Lost during the Conversion, only MyBB Data, not the IPB Data!<br />
				  Please read the readme.txt and edit the Converter Settings correctly; if you are sure, lets start the Import System...</p>
				  <p><font size="5">Please Copy all User uploaded files from invision_path/uploads to mybb/uploads, otherwise the Attachment Import will fails</font></p>
				  <br /><br />
				  <p><a href="invision_to_mybb.php?import=usergroups">Cick to start the Import System</a></p>
				  ';
				  
}

// After we import the IPB Attachments we print out an Finished Screen, lets go!
function import_finished()
{
	print '<p>Conversion is Complete.</p>';
	print 'All your Invision Power Board Data is imported into your new MyBB. Please Double Check all
	     Rights and Settings! <br />
	     If its necessary, change some Options. Have Fun with your MyBB and your Community!';
}


// Extra Functions for the Importer
function ipb_html($post)
{

	$post = preg_replace('#<u>([^"]*)</u>#siU', '[u]\\1[/u]', $post);
	$post = preg_replace('#<b>([^"]*)</b>#siU', '[b]\\1[/b]', $post);
	$post = preg_replace('#<i>([^"]*)</i>#siU', '[i]\\1[/i]', $post);
	$post = preg_replace('#<span style=\'font-family:([^"]*)\'>([^"]*)</span>#siU', '[font=\\1]\\2[/font]', $post);
	$post = preg_replace('#<span style=\'color:([^"]*)\'>([^"]*)</span>#siU', '[color=\\1]\\2[/color]', $post);
	$post = preg_replace('#<a href=\'(http://|https://|ftp://|news://)([^"]*)\' target=\'_blank\'>([^"]*)</a>#siU', '[url=\\1\\2]\\3[/url]', $post);
	
	$post = preg_replace('#<a href=\'(ed2k://)([^"]*)\' title=\'ed2klink\'>([^"]*)</a>#siU', '[url=\\1\\2]\\3[/url]', $post);
	$post = preg_replace('#<a href=\'(http://)([^"]*)\'>([^"]*)</a>#siU', '[url=\\1\\2]\\3[/url]', $post);

	$post = preg_replace('#<img src=\'([^"]*)\' border=\'0\' alt=\'user posted image\'(\s/)?>#siU', '[img]\\1[/img]', $post);
	$post = str_replace("<img src='","[img]",$post);
	$post = preg_replace('#<a href=\'mailto:([^"]*)\'>([^"]*)</a>#siU', '[email=\\1]\\2[/email]', $post);

	$post = preg_replace('#<ul>#siU', '[list]', $post);
	$post = preg_replace('#<ol type=\'[1|i]\'>#siU', '[list=1]', $post);
	$post = preg_replace('#<ol type=\'a\'>#siU', '[list=a]', $post);
	$post = preg_replace('#<li>([^"]*)</li>#siU', "[*]\\1\n", $post);
	$post = preg_replace('#</ul>#siU', '[/list]', $post);
	$post = preg_replace('#</ol>#siU', '[/list]', $post);

	$post = preg_replace('#<!--emo&([^"]*)-->([^"]*)<!--endemo-->#siU', '\\1', $post);
	$post = preg_replace('#<!--c1-->([^"]*)<!--ec1-->#siU', '[code]', $post);
	$post = preg_replace('#<!--c2-->([^"]*)<!--ec2-->#siU', '[/code]', $post);
	$post = preg_replace('#<!--QuoteBegin-->([^"]*)<!--QuoteEBegin-->#siU', '[quote][b]', $post);
	$post = preg_replace('#<!--QuoteBegin-{1,2}([^"]*)\+-->([^"]*)<!--QuoteEBegin-->#si', '[quote][i]Originally posted by \\1[/i]<br />[b]', $post);
	$post = preg_replace('#<!--QuoteBegin-{1,2}([^"]*)\+([^"]*)-->([^"]*)<!--QuoteEBegin-->#si', '[quote][i]Originally posted by \\1[/i]@\\2<br />[b]', $post);
	$post = preg_replace('#<!--QuoteEnd-->([^"]*)<!--QuoteEEnd-->#siU', '[/b][/quote]', $post);
	$post = preg_replace('#<span style=\'font-size:(.+?)pt;line-height:100%\'>(.+?)</span>#e', 'unconvert_size("\\1", "\\2")', $post);
	$post = preg_replace('#<!--EDIT\|([^"]*)\|([^"]*)-->#siU', 'Last edited by \\1 at \\2', $post);

	$post = str_replace("<br />","\n",$post);
	$post = str_replace("<br>","\n",$post);
	$post = str_replace("&amp;","&",$post);
	$post = str_replace("&lt;","<",$post);
	$post = str_replace("&gt;",">",$post);
	$post = str_replace("&quot;","\"",$post);
	$post = str_replace("&#039;","'",$post);
	$post = str_replace("&#033;","!",$post);
	$post = str_replace("&#124;","|",$post);

	$post = preg_replace('#<a href=\'([^"]*)\' target=\'_blank\'><img src=\'([^"]*)\' alt=\'([^"]*)\' width=\'([^"]*)\' height=\'([^"]*)\' class=\'([^"]*)\' /></a>#siU', '[img]\\2[/img]', $post);

	$post = preg_replace('#<!--aimg-->#siU', '', $post);
	$post = preg_replace('#<!--/aimg-->#siU', '', $post);
	$post = preg_replace('#--Resize_Images_Alt_Text--#siU', '', $post);
	$post = preg_replace('#<!--Resize_Images_Hint_Text-->#siU', '', $post);

	$post = preg_replace('#<!--QuoteBegin-{1,2}([^"]*)\+-->([^"]*)<!--QuoteEBegin-->#siU', '[quote]Originally posted by \\1<br />[b]', $post);
	$post = preg_replace('#<!--QuoteBegin-{1,2}([^"]*)\+([^"]*)-->([^"]*)<!--QuoteEBegin-->#siU', '[quote]Originally posted by \\1@\\2<br />[b]', $post);

   return trim(stripslashes($post));;
}

function unconvert_size($size="", $text="")
{
	switch($size)
	{
	   case '21':
		  $size=4;
		  break;
	   case '14':
		  $size=3;
		  break;
	   case '8':
		  $size=1;
		  break;
	   default:
		  $size=2;
		  break;
	}
	return '[SIZE='.$size.']'.$text.'[/SIZE]';
}
	
	
function get_forum_ids(&$tableprefix, $pad=0)
{
	
	$forums = mysql_query("SELECT fid, importforumid FROM " . $tableprefix . "forums");
	while ($forum = mysql_fetch_array($forums))
	{
		if ($pad)
		{
			$impforumid = intval($forum['importforumid']);
			$forumid["$impforumid"] = $forum['fid'];
		}
		else
		{
			$forumid["$forum[importforumid]"] = $forum['fid'];
		}
	}
	mysql_free_result($forums);
	return $forumid;
}

function get_category_ids(&$tableprefix)
{
	
	$forums = mysql_query("SELECT fid, importcategoryid FROM " . $tableprefix . "forums WHERE importcategoryid <> 0");
	while ($forum = mysql_fetch_array($forums))
	{
		$categoryid["$forum[importcategoryid]"] = $forum['fid'];
	}
	mysql_free_result($forums);
	return $categoryid;
}

// Returns an array of the user ids key'ed to the import user id's $userid[$importuserid] = $user[userid]
function get_user_ids(&$tableprefix, $do_int_val = false)
{
	$users = mysql_query("SELECT uid, username, importuserid FROM " . $tableprefix . "users WHERE importuserid <> 'null'");
	while ($user = mysql_fetch_array($users))
	{
		if ($do_int_val)
		{
			$importuserid = intval($user['importuserid']);
		}
		else
		{
			$importuserid = $user['importuserid'];
		}

		$userid["$importuserid"] = $user['uid'];
	}
	mysql_free_result($users);
	return $userid;
}

// Returns an array of the import user ids key'ed to the username
function get_username(&$tableprefix)
{
	
	$users = mysql_query("SELECT username, uid, importuserid AS importuserid FROM " . $tableprefix ."users WHERE importuserid <> 0");
	while ($user = mysql_fetch_array($users))
	{
		// The normal
		$username["$user[importuserid]"] 					= $user['username'];

		// The reverse
		$username['uid']["$user[uid]"] 						= $user['username'];
	}
	mysql_free_result($users);
	return $username;
}


// Returns a MyBB thread id array
function get_threads_ids(&$tableprefix)
{
	
	$threads = mysql_query("SELECT tid, importthreadid FROM " . $tableprefix . "threads WHERE importthreadid <> 0");
	while ($thread = mysql_fetch_array($threads))
	{
		$threadid["$thread[importthreadid]"] = $thread['tid'];
	}
	mysql_free_result($threads);
	return $threadid;
}

function get_ipb_poll_voters($table_prefix, $poll_id)
{
	global $INFO;
		
	$ipb_db = mysql_connect($INFO['sql_host'], $INFO['sql_user'], $INFO['sql_pass']);
	mysql_select_db($INFO['sql_database'], $ipb_db);
	
	$return_array = array();
	
	// Check that there isn't a empty value
	if(empty($poll_id)) { return $return_array; }
	
	$sql = "SELECT member_id FROM " .$table_prefix."voters WHERE tid = " .$poll_id;

	$poll_voters = mysql_query($sql) or die(mysql_error());
	while ($voter = mysql_fetch_array($poll_voters))
	{
		$return_array[] = $voter;
	}		

	return $return_array;
}

function unhtmlspecialchars($text)
{
	return str_replace(array('&lt;', '&gt;', '&quot;', '&amp;'), array('<', '>', '"', '&'), $text);
}

function get_ipb_attachment($path, $file_name)
{
	$file_address = $path . "/" . $file_name;
	if($file_name == '' OR !is_file($file_address))
	{
		return false;
	}
	$the_file = array();
	$file = fopen($file_address,'rb');
	if($file AND filesize($file_address) > 0)
	{
		$the_file['data']		= fread($file, filesize($file_address));
		$the_file['filesize']	= filesize($file_address);
		$the_file['filehash']	= md5($the_file['data']);
	}
	return $the_file;
}

function getextention($file)
{
	return strtolower(substr(strrchr($file, "."), 1));
}

function strip_file_ext($name) 
{
	if(($pos = strrpos($name, '.')) === false) return $name;
	return substr($name, 0, $pos);
}


function generate_thumbnail($file, $path, $filename, $maxheight, $maxwidth)
{
	if(!function_exists("imagecreate"))
	{
		$thumb['code'] = 3;
		return $thumb;
	}
	list($imgwidth, $imgheight, $imgtype, $imgattr) = getimagesize($file);
	if(($imgwidth > $maxwidth) || ($imgheight > $maxheight))
	{
		if($imgtype == 3)
		{
			if( function_exists("imagecreatefrompng"))
			{
				$im = imagecreatefrompng($file);
			}
		}
		elseif($imgtype == 2)
		{
			if(function_exists("imagecreatefromjpeg"))
			{
				$im = imagecreatefromjpeg($file);
			}
		}
		elseif($imgtype == 1)
		{
			if(function_exists("imagecreatefromgif"))
			{
				$im = imagecreatefromgif($file);
			}
		}
		else
		{
			$thumb['code'] = 3;
			return $thumb;
		}
		if(!$im)
		{
			$thumb['code'] = 3;
			return $thumb;
		}
		$scale = scaleImage($imgwidth, $imgheight, $maxwidth, $maxheight);
		$thumbwidth = $scale['width'];
		$thumbheight = $scale['height'];
		$thumbim = @imagecreatetruecolor($thumbwidth, $thumbheight);
		if($thumbim)
		{
			imagecopyresampled($thumbim, $im, 0, 0, 0, 0, $thumbwidth, $thumbheight, $imgwidth,$imgheight);
		}
		else
		{
			$thumbim = imagecreate($thumbwidth, $thumbheight);
			imagecopyresized($thumbim, $im, 0, 0, 0, 0, $thumbwidth, $thumbheight, $imgwidth, $imgheight);
		}
		@imagedestroy($im);
		if(!function_exists("imagegif") && $imgtype == 1)
		{
			$filename = str_replace(".gif", ".jpg", $filename);
		}
		switch($imgtype)
		{
			case 1:
				if(function_exists("imagegif"))
				{
					@imagegif($thumbim, $path."/".$filename);
				}
				else
				{
					@imagejpeg($thumbim, $path."/".$filename);
				}
				break;
			case 2:
				@imagejpeg($thumbim, $path."/".$filename);
				break;
			case 3:
				@imagepng($thumbim, $path."/".$filename);
				break;
		}
		@chmod($path."/".$filename, 0666);
		@imagedestroy($thumbim);
		$thumb['code'] = 1;
		$thumb['filename'] = $filename;
		return $thumb;
	}
	else
	{
		return array("code" => 4);
	}
}

function scaleImage($width, $height, $maxwidth, $maxheight)
{
	$newwidth = $width;
	$newheight = $height;

	if($width > $maxwidth)
	{
		$newwidth = $maxwidth;
		$newheight = ceil(($height*(($maxwidth*100)/$width))/100);
		$height = $newheight;
		$width = $newwidth;
	}
	if($height > $maxheight)
	{
		$newheight = $maxheight;
		$newwidth = ceil(($width*(($maxheight*100)/$height))/100);
	}
	$ret['width'] = $newwidth;
	$ret['height'] = $newheight;
	return $ret;
}

print '
</body>
</html>
';

?>